// Copyright (C) 2018 Katayama Hirofumi MZ.
// License: CC BY
#include <windows.h>
#include <cstdio>

extern "C"
int wmain(int argc, wchar_t **wargv)
{
    using namespace std;
    if (argc != 3)
    {
        fprintf(stderr, "invalid arguments\n");
        fprintf(stderr, "Usage: PickIcon <file.dll> <index>\n");
        return -1;
    }

    if (HINSTANCE hShell32 = LoadLibraryA("shell32"))
    {
        // PickIconDlg
        typedef BOOL (WINAPI *PICKICONDLG)(HWND, LPWSTR, UINT, INT*);
        if (PICKICONDLG pPickIconDlg = (PICKICONDLG)GetProcAddress(hShell32, "PickIconDlg"))
        {
            INT nIndex = _wtoi(wargv[2]);
            printf("FilePath: %S\n", wargv[1]);
            printf("nIndex: %d\n", nIndex);
            BOOL bRet = (*pPickIconDlg)(NULL, wargv[1], lstrlen(wargv[1]), &nIndex);
            printf("bRet: %d\n", bRet);
            printf("nIndex: %d\n", nIndex);
        }
        FreeLibrary(hShell32);
        return 0;
    }

    return 1;
}
